#version 300 es

precision highp float;

layout(location = 0) out vec4 F;
in vec2 v_tex_coord;

uniform sampler2D texture_tfm;
uniform sampler2D texture_v_bilateral_iter1;

#define use_texture texture_v_bilateral_iter1

void main() 
{
    const float sigma_e = 1.0;
    float sigma_r = 1.6 * sigma_e;
    sigma_r = 5.0;
    float tau = 0.97;

    float two_sigma_e_squared = 2.0 * sigma_e * sigma_e;
    float two_sigma_r_squared = 2.0 * sigma_r * sigma_r;

    vec2 uv = v_tex_coord;
    vec2 textire_size = vec2(textureSize(use_texture, 0));

    vec2 n = texture(texture_tfm, uv).xy;
    vec2 nabs = abs(n);
    float ds = 1.0 / ((nabs.x > nabs.y) ? nabs.x : nabs.y);
    n /= textire_size;

    vec2 sum = texture(use_texture, uv).xx;
    vec2 norm = vec2(1.0, 1.0);

    float half_width = 10.0;
    for (float d = ds; d <= half_width; d += ds) {
        vec2 kernel = vec2(exp(-d * d / two_sigma_e_squared), 
                           exp(-d * d / two_sigma_r_squared));

        norm += 2.0 * kernel;

        vec2 L0 = texture(use_texture, uv - d * n).xx;
        vec2 L1 = texture(use_texture, uv + d * n).xx;
        
        sum += kernel * (L0 + L1);
    }

    sum /= norm;

    float diff = 100.0 * (sum.x - tau * sum.y);

    F = vec4(diff, 0.0, 0.0, 1.0);
}
