#version 300 es

precision highp float;

layout(location = 0) out vec4 F;
in vec2 v_tex_coord;

uniform sampler2D texture_lab;


void main() 
{
   vec2 uv = v_tex_coord;
   vec2 textire_size = vec2(textureSize(texture_lab, 0));

    vec2 d = 1.0 / textire_size;

    vec4 u = (
             -1.0 * texture(texture_lab, uv + vec2(-d.x, -d.y)) +
             -2.0 * texture(texture_lab, uv + vec2(-d.x,  0.0)) + 
             -1.0 * texture(texture_lab, uv + vec2(-d.x,  d.y)) +
             +1.0 * texture(texture_lab, uv + vec2( d.x, -d.y)) +
             +2.0 * texture(texture_lab, uv + vec2( d.x,  0.0)) + 
             +1.0 * texture(texture_lab, uv + vec2( d.x,  d.y))
             ) / 4.0;

    vec4 v = (
             -1.0 * texture(texture_lab, uv + vec2(-d.x, -d.y)) + 
             -2.0 * texture(texture_lab, uv + vec2( 0.0, -d.y)) + 
             -1.0 * texture(texture_lab, uv + vec2( d.x, -d.y)) +
             +1.0 * texture(texture_lab, uv + vec2(-d.x,  d.y)) +
             +2.0 * texture(texture_lab, uv + vec2( 0.0,  d.y)) + 
             +1.0 * texture(texture_lab, uv + vec2( d.x,  d.y))
             ) / 4.0;

    F = vec4(vec3(dot(u.xyz, u.xyz), dot(u.xyz, v.xyz), dot(v.xyz, v.xyz)), 1.0);
}

